import { Change, Created } from './change';
import { ChainEntity, ChainKey } from './entity';
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.event.ChainEntityEvent <br/>
*/
export interface ChainEntityEvent<E extends ChainEntity> extends ChainEvent<E> {
    readonly key?: ChainKey;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.event.ChainEvent <br/>
*/
export interface ChainEvent<P> {
    readonly module?: string;
    readonly name?: string;
    readonly payload?: P;
    readonly timeStamp?: Date;
    readonly tx?: string;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.event.ChainEventBase <br/>
*/
export interface ChainEventBase<P> extends ChainEvent<P> {
    module?: string;
    name?: string;
    timeStamp?: Date;
    readonly tx?: string;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.event.ChainEventBean <br/>
*/
export interface ChainEventBean<P> extends ChainEventBase<P> {
    payload?: P;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.base.core.event.RestEvent <br/>
*/
export interface RestEvent extends Created {
    created?: Change;
    eventId?: string;
    method?: string;
    path?: string;
    queryParams?: {
        [key: string]: string;
    };
    remoteAddress?: string;
    requestBody?: Object;
    requestHeaders?: {
        [key: string]: string;
    };
    responseBody?: Object;
    responseStatusCode?: number;
    took?: number;
}
